il vaut mieux ouvrir ce document avec Emacs et Org mode

* les références
** l'origine de cette présentation

*** la proposition de présentation de Pierre Gambarotto

*** mon inscription au MOOC "Recherche reproductible : principes méthodologiques pour une science transparente"
:PROPERTIES:

:END:

*** la reproductibilité du travail fait
:PROPERTIES:

:END:

*** GNU Emacs et Org mode ;)
:PROPERTIES:

:END:

** les sources des informations pour une recherche reproductible
:PROPERTIES:
:END:

*** [[https://rr-france.github.io/bookrr/][Vers une recherche reproductible]]

- https://rr-france.github.io/bookrr/
- par Loïc Desquilbet, Sabrina Granger, Boris Hejblum, Arnaud Legrand,
  Pascal Pernot, Nicolas Rougier
- [[https://rr-france.github.io/bookrr/C-code-env.html#les-systemes-de-gestion-de-paquets][16.3 Les systèmes de gestion de paquets]]

L’approche la plus aboutie pour la reproduction de l’environnement
logiciel s’appuie sur les systèmes de gestion de paquets fonctionnels
tels que :

*** le MOOC
- https://www.fun-mooc.fr/courses/course-v1:inria+41016+session02/about
* prise de note: du papier à l'indexation numérique
** prise de note
*** critères importants pour une bonne prise de note
 - structuration
 - indexation
 - concervation

sinon l'utilité ne dépasse pas notre mémoire

** exemples

 - index de John Locke
 - l'armoire de Placcius
 - tablettes de cires
 - Fulgence Tapir

** exemple: mind mapping
 #+NAME:   fig:SED-HR4049
 [[./img/IMG20160211115808.jpg]]


   #+attr_html: :width 100px
 #+attr_latex: :width 100px

** exemple: bullet journal

Ryder Carroll, La méthode Bullet Journal

 #+NAME:   fig:SED-HR4049
 [[./img/9782863744864-001-T.jpeg]]

** support numérique

 - grande flexibilité d'organisation, de réorganisation, de structuration
 - outils d'archivages fiables
 - outils d'indexation puissants

** fichiers textes, balisage léger

*** fichiers textes

 - pérennité et lisibilité
 - indexation
 - gestion de version

choisir le format texte à moins d'avoir une bonne raison de ne pas le
faire

*** balisage léger: structurer les notes

langage de balisage + fichier texte

 - makdown
 - reStructuredText
 - AsciiDoc
 - org-mode
 - ...

 - démonstration de markdown et pandoc
** pérennité et évolutivité
*** le papier montre vite ses limites
*** traitement de texte et la gestion des corrections
 - la sauvegarde est à faire indépendamment de la gestion des corrections
 - pas un fichier texte
*** wiki
 - la sauvegarde est à la charge de l'utilisateur
 - un seul fichier à la fois
*** outil de gestion de version

** métadonnées et indexation

*** indexation des fichiers texte
- recherche "full-text"
- recherche avec des étiquettes
  <!-- étiquette-1: -->
*** indexation des fichiers binaires
- les métdonnées (exemple avec exiftool sur des fichiers jpeg)
*** les outils

 - recoll
 - DocFetcher
 - ...
** démo recoll

- recherche de guix
- stigmergy ext:pdf

* le document computationnel
** exemples de recherches non reproductibles
*** Growth in a Time of Debt, par Reinhart et Rogoff (2010)
:PROPERTIES:

:END:
- utilisé pour justifier des politiques d'austérité budgétaire
- non publication des procédures de calcul et des données
*** IRM fonctionnelle d'un saumon mort (2010, 2016)
:PROPERTIES:

:END:
- interpelle la communauté sur des faiblesses méthodologiques
- les données très volumineuses ne sont pas archivées
*** étude de la structure de protéines (2006)
:PROPERTIES:

:END:
- bug dans un code passé d'un labo à un autre
** pourquoi est-ce difficile de reproduire des resultats
*** manque d'informations
:PROPERTIES:

:END:
- sources et données
- choix
*** l'usage intensif de l'ordinateur
:PROPERTIES:

:END:
- les logiciels "point and click"
- pile logicielle complexe
- bug
** pourquoi est-ce difficile de reproduire des resultats
*** manque de rigueur et d'organisation
:PROPERTIES:

:END:
- pas de backup
- pas d'historique
- pas de contrôle qualité
*** dimension culturelle et sociale
:PROPERTIES:

:END:

 - les /faiblesses/ deviendraient évidentes...
 - quelqu'un pourrait trouver /une erreur/...
 - quelqu'un pourrait en /tirer avantage à ma place/...
** la science moderne

 - iteration entre collecte de données et analyse

 - publication

la recherche reproductible, c'est pouvoir:

 - inspecter (justifier, comprendre)
 - refaire (vérifier, corriger, réutiliser)

les analyses à partir des données dans tous les domaines des sciences
** replicability != reproducibility

- répliquer != reproduire

- Drummond, Chris. (2009). Replicability Is Not Reproducibility: Nor
  Is It Good Science. Proceedings of the Evaluation Methods for
  Machine Learning Workshop at the 26th ICML.

la signification de *recherche reproductible* dépend du domaine de
recherche

** le document computationnel
c'est un document qui présente:

- les explications
- le code de calcul
- les données si possible
- les résultats

*** les environnements présentés

- Jupyter
- Rstudio/knitR
- Org mode
** le document computationnel

articles de référence

*** A Multi-Language Computing Environment for Literate Programming and Reproducible Research

par Eric Schulte, Dan Davison, Thomas Dye, Carsten Dominik dans
Journal of Statistical Software (2012, volume 46, issue 3)

http://dx.doi.org/10.18637/jss.v046.i03

*** An Effective Git And Org-Mode Based Workflow For Reproducible
Research. Luka Stanisic, Arnaud Legrand, Vincent Danjean. Operating
Systems Review, Association for Computing Machinery, 2015, 49,
pp.61 - 70. <10.1145/2723872.2723881>. <hal-01112795>

** le document computationnel
*** programmation lettrée (literate programming)
*** recherche reproductible (reproductible research)
*** ref Zotero                                                     :noexport:

[[zotero://select/items/1_94AKRP5A][« Schulte et al. - 2012 - A Multi-Language Computing Environment for Literat.pdf », s. d.]]

** programmation lettrée
*** démo
- le document, [[file:cocktail/cocktail.org::*Literate%20programming---cocktail%20sort][Literate programming---cocktail sort]]
- générer le fichier .tex, le compiler, le visualiser
  C-c C-e l l
  [[pdfview:/Users/dbonnafo/cours/capitoul-06-2019/cocktail/cocktail.pdf::1][/Users/dbonnafo/cours/capitoul-06-2019/cocktail/cocktail.pdf]]
- générer le fichier .c, le compiler, l'executer
  C-c C-v t
** recherche reproductible
*** démo du MOOC
- [[file:grippe/analyse-syndrome-grippal-orgmode+R.org][le document]]
- produire le html

** et du Java
#+HEADERS: :classname HelloWorld :cmdline "-cp ."
#+begin_src java  :results output :exports both
  public class HelloWorld {
      public static void main(String[] args) {
          System.out.println("Hello, World");
      }
  }
#+end_src

** commandes utiles                                                :noexport:
(org-toggle-inline-images)

(org-babel-remove-result-one-or-many) C-c C-v k (+C-u)

(org-babel-execute-buffer)

** literate devops
*** execution de commande
#+begin_src shell :session foo :results output :exports both
ls -alrt *.org
#+end_src

*** 2e commande

- http://howardism.org/Technical/Emacs/literate-devops.html

#+begin_src shell :session foo :results table :exports both
/opt/local/bin/port installed | tail -n 10
#+end_src

* conclusion
** Le code source des logiciels: un patrimoine - L'Appel de Paris[fn:2]

Availability of the source code of these software tools is one of the
prerequisites to ensure that results can be reproduced, understood and
trusted. (p. 8)

** "software commons"

#+NAME:   fig:SED-HR4049
#+attr_html: :width 100px
#+attr_latex: :width 100px
 [[./img/commun.jpg]]

** GTD

** ACM code of ethic

https://www.acm.org/code-of-ethics
* à faire							   :noexport:
** TODO lancer recoll
- guix
- stigmergy
* commandes utiles						   :noexport:
(org-zotxt-mode)
C-u C-c " i

(org-hide-block-all)
* config 							   :noexport:
#+TITLE: Les outils logiciels pour la recherche reproductible
#+SUBTITLE: (pour un travail reproductible)
#+AUTHOR: David Bonnafous
#+DATE: jeudi 20 juin 2019
#+LANGUAGE: fr

#+OPTIONS: H:2 toc:nil num:t
#+LATEX_CLASS: beamer
#+LATEX_CLASS_OPTIONS: [presentation]

#+LATEX_HEADER: \usepackage{polyglossia}
#+LATEX_HEADER: \setdefaultlanguage{french}


%%#+BEAMER_THEME: Madrid
%%#+BEAMER_THEME: Rochester


#+COLUMNS: %45ITEM %10BEAMER_ENV(Env) %10BEAMER_ACT(Act) %4BEAMER_COL(Col) %8BEAMER_OPT(Opt)

;; Local Variables:
;; eval: (setq org-latex-with-hyperref "\\hypersetup{\n unicode=true,\n pdfauthor={%a},\n pdftitle={%t},\n pdfkeywords={%k}, pdfsubject={%d},\n pdfcreator={%c}, \n pdflang={%L}}\n")
;; eval: (setq org-confirm-babel-evaluate nil)
;; eval: (setq ispell-dictionary "francais")
;; eval: (set-input-method "french-prefix")
;; End:
# Local IspellDict: francais

* Footnotes

[fn:2] https://en.unesco.org/foss/paris-call-software-source-code

[fn:1]Digital Object Identifier,
